;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;*=====================================================================*/
;*    serrano/prgm/project/bigloo/comptime1.5/0cfa/walk.scm ...        */
;*                                                                     */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Wed May  5 15:30:25 1993                          */
;*    Last change :  Thu Sep 30 10:00:09 1993 (serrano)                */
;*                                                                     */
;*    La `control flow analysis'                                       */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    Le module                                                        */
;*---------------------------------------------------------------------*/
(module 0cfa_walk
   (include "Var/variable.sch"
	    "Tools/trace.sch")
   (import  tools_speek
	    tools_error
	    tools_shape
	    0cfa_0cfa
	    0cfa_reduce
	    0cfa_tree
	    0cfa_diet)
   (export  (0cfa tree)))

;*---------------------------------------------------------------------*/
;*    0cfa ...                                                         */
;*---------------------------------------------------------------------*/
(define (0cfa tree)
   (verbose "   . 0cfa (round 0)")
   (start-partial-error "0cfa")
   (add-0cfa-in-tree! tree)
   (0cfa! tree)
   (0cfa-reduce-tree! tree)
   (0cfa-diet! tree)
   (rm-0cfa-in-tree! tree)
   (cleanup-variables!)
   tree))

