;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;*=====================================================================*/
;*    serrano/prgm/project/bigloo/runtime1.6/Llib/foreign.scm ...      */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Oct 19 08:53:26 1993                          */
;*    Last change :  Mon May 16 16:48:06 1994 (serrano)                */
;*    -------------------------------------------------------------    */
;*    La manipulation des types etrangers (partie Bigloo)              */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    Le module                                                        */
;*---------------------------------------------------------------------*/
(module __foreign
   (foreign
    (define bsymbol  c-foreign-id (bforeign)           "FOREIGN_ID")
    (define bool     c-foreign? (obj)                  "FOREIGNP")
    (define bool     c-foreign-is? (obj obj)           "FOREIGN_ISP")
    (define long     sizeof (obj)                      "sizeof")
    (bforeign        c-make-foreign (bsymbol long)     "allocate_foreign")
    (bforeign        c-cforeign->bforeign (bsymbol foreign)
                     "cforeign_to_bforeign")
    (define foreign  c-bforeign->cforeign (bforeign)
                     "BFOREIGN_TO_CFOREIGN")
    (define foreign  c-foreign-reference (foreign)    "*")
    (define foreign  c-foreign-address  (foreign)     "&")
    (define foreign  c-foreign-struct-ref (bforeign obj obj)
                     "FOREIGN_STRUCT_REF")
    (define obj      c-foreign-struct-set! (bforeign obj obj foreign)
                     "FOREIGN_STRUCT_SET")
    (foreign         c-bobj->cforeign (obj) "bobj_to_cforeign")
    (define foreign  c-array-ref  (obj obj bforeign long) "FOREIGN_ARRAY_REF")
    (define function c-function-address (foreign) "FUNCTION_ADDRESS")
    (define obj      c-array-set! (obj obj bforeign long obj)
                     "FOREIGN_ARRAY_SET")
    (define bool     c-foreign-eq? (bforeign bforeign) "FOREIGN_EQP")
    (define bool     c-foreign-null? (bforeign)        "FOREIGN_NULLP"))
   (export (inline foreign-null? f)))

;*---------------------------------------------------------------------*/
;*    foreign-null? ...                                                */
;*---------------------------------------------------------------------*/
(define-inline (foreign-null? f)
   (and (c-foreign? f)
	(c-foreign-null? f)))


